<template lang="pug">
BaseCard(tabIndex='0').highlightOnFocus
  template(v-slot:header)
    .d-flex.justify-content-between
      div #[h5 Addh Extra Sources for {{ zone }}]
      .ml-auto.clickable(@click='setEdit(true)' v-if='isConnected && !inEdit')
        kbd.keyHint.mr-2(v-if="showKeyHints") E
        i.fa.fa-cog
      .ml-auto.clickable(@click='setEdit(false)' v-if='isConnected && inEdit')
        kbd.keyHint.mr-2(v-if="showKeyHints") Esc
        i.fa.fa-times
  li(v-if='!isConnected' key='1')
    div.text-muted Connecting to {{ zone }} ADDH Service...
  li(v-show='isConnected' key='2')
    BaseModalLoader(:isLoading="loading || isSendingCommand")

    strong XML Dataset/Parameters: Single Value
    table.table.table-sm.table-hover.mt-2.text-center
      thead
        tr.table-head #[th From Service] #[th From Name] #[th Destination] #[th.w-10(v-if="inEdit") Actions]
      tbody
        tr(v-if="singleEditData.length === 0 && !inEdit")
          td(colspan="3") No sources defined.
        tr(:key="data.id" v-for="data in singleEditData"
            :class="{ 'table-warning': hasMissingFields(data) }")
          td
            BaseInput(v-model='data.fromService' :inEdit='inEdit' :noEditIcon='true')
          td
            BaseInput(v-model='data.fromName' :inEdit='inEdit' :noEditIcon='true')
          td
            BaseInput(v-model='data.destination' :inEdit='inEdit' :noEditIcon='true')
          td(v-if="inEdit")
            button.btn.btn-danger.x-rm(type='button' @click="removeSource(data.id)")
              i.fa.fa-times
        tr(v-if="inEdit")
          td(colspan="3")
          td(v-if="inEdit")
            button.btn.btn-success.x-add(type='button' @click="addSource(DataSourceType.SINGLE_DATA)")
              i.fa.fa-plus

    strong XML Dataset/Parameters: All Values
    table.table.table-sm.table-hover.mt-2.text-center
      thead
        tr.table-head #[th From Service] #[th Destination Prefix] #[th.w-10(v-if="inEdit") Actions]
      tbody
        tr(v-if="allEditData.length === 0 && !inEdit")
          td(colspan="2") No sources defined.
        tr(:key="data.id" v-for="data in allEditData"
            :class="{ 'table-warning': hasMissingFields(data) }")
          td
            BaseInput(v-model='data.fromService' :inEdit='inEdit' :noEditIcon='true')
          td
            BaseInput(v-model='data.destinationPrefix' :inEdit='inEdit' :noEditIcon='true')
          td(v-if="inEdit")
            button.btn.btn-danger.x-rm(type='button' @click="removeSource(data.id)")
              i.fa.fa-times
        tr(v-if="inEdit")
          td(colspan="2")
          td(v-if="inEdit")
            button.btn.btn-success.x-add(type='button' @click="addSource(DataSourceType.ALL_DATA)")
              i.fa.fa-plus

    strong Basic DIM Service
    table.table.table-sm.table-hover.mt-2.text-center
      thead
        tr.table-head #[th From Service] #[th Destination] #[th.w-10(v-if="inEdit") Actions]
      tbody
        tr(v-if="valueEditData.length === 0 && !inEdit")
          td(colspan="2") No sources defined.
        tr(:key="data.id" v-for="data in valueEditData"
            :class="{ 'table-warning': hasMissingFields(data) }")
          td
            BaseInput(v-model='data.fromService' :inEdit='inEdit' :noEditIcon='true')
          td
            BaseInput(v-model='data.destination' :inEdit='inEdit' :noEditIcon='true')
          td(v-if="inEdit")
            button.btn.btn-danger.x-rm(type='button' @click="removeSource(data.id)")
              i.fa.fa-times
        tr(v-if="inEdit")
          td(colspan="2")
          td(v-if="inEdit")
            button.btn.btn-success.x-add(type='button' @click="addSource(DataSourceType.VALUE)")
              i.fa.fa-plus

    // Submit
    BaseAnimationBlock(anim='height' :appear='false')
      .row.mt-2.justify-content-end(v-show='inEdit')
        .col-auto
          button.btn.btn-primary.mx-1.x-submit(type='submit' @click='submit()')
            kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
            | Submit
</template>
<script>

export { default } from '../AddhExtra/AddhExtra.vue.js';

</script>

<style scoped>
.w-10 {
  width: 10%;
}
</style>
